#include <stdio.h>
#include "stm32f4xx.h"

int Java_app_I2CBus_I2CRead(int slaveAddr, int regAddr, int bytes) {
	int value = 0;
	int index;
	
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, (slaveAddr&0x7F)<<1, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) __NOP();
	I2C_SendData(I2C3, regAddr&0xFF);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, (slaveAddr&0x7F)<<1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED)) __NOP();
	
	for(index=0; index<bytes-1; index++) {
		I2C_AcknowledgeConfig(I2C3, ENABLE);
		I2C_GenerateSTOP(I2C3, DISABLE);
		while( !I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_RECEIVED)) __NOP();
		value |= I2C_ReceiveData(I2C3)<<(index*8);
	}
	
	I2C_AcknowledgeConfig(I2C3, DISABLE);
	I2C_GenerateSTOP(I2C3, ENABLE);
	while( !I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_RECEIVED)) __NOP();
	value |= I2C_ReceiveData(I2C3)<<(index*8);
	return value;
}

void Java_app_I2CBus_I2CWrite(int slaveAddr, int regAddr, int value, int bytes) {
	int index;
	
	I2C_GenerateSTART(I2C3, ENABLE);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_MODE_SELECT)) __NOP();
	I2C_Send7bitAddress(I2C3, (slaveAddr&0x7F)<<1, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)) __NOP();
	
	I2C_SendData(I2C3, regAddr&0xFF);
	while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	
	for(index=0; index<bytes; index++) {
	    I2C_SendData(I2C3, value>>(index*8));
			while (!I2C_CheckEvent(I2C3, I2C_EVENT_MASTER_BYTE_TRANSMITTED));	
	}
	I2C_GenerateSTOP(I2C3, ENABLE);
}
